
function nonrecursiveExport sourceDir destDir newerOnly = 
(
	escapeEnabled = false	

	silent = SilentMode()
	SetSilentMode(true)
	
	--CreateDialog B3dBatchProgress 340 140

	for f in getFiles (sourceDir + "*.max") do 
  	(
		
		if keyboard.escPressed then exit
		
		b3dFile = destDir + getFilenameFile f + ".b3d"

		-- newerOnly
		if (newerOnly==true) then 
		(
			if ((getFiles b3dFile).count !=0) then
			(
				modDateMax = getFileModDate f
				dateMax = filterString modDateMax"/: "
				--print dateMax
				
				modDateB3d = getFileModDate b3dFile
				dateB3d = filterString modDateB3d"/: "
				--print dateB3d
				
				-- check year
				if (dateB3d[3] as integer > dateMax[3] as integer) then continue
				-- check month
				if (dateB3d[1] as integer > dateMax[1] as integer) then continue
				-- check day
				if (dateB3d[2] as integer > dateMax[2] as integer) then continue
				-- check hour
				if (dateB3d[7]=="PM" and dateMax[7]=="AM") then continue
				if (dateB3d[4] as integer > dateMax[4] as integer) then continue
				-- check minute
				if (dateB3d[5] as integer > dateMax[5] as integer) then continue
				-- check seconds!!
				if (dateB3d[6] as integer > dateMax[6] as integer) then continue
			)
		)
		
		-- for relative paths
		sTmp = f as string
		sNew = ""
		
		if findString sTmp "\\\\" == 1 then sNew = "\\\\"
		aTmpArray = filterString sTmp "\\"
		for i = 1 to aTmpArray.count - 1 do
		(
			sNew +=	aTmpArray[i]
			sNew += "\\"
		)
		
		sysInfo.currentDir = sNew
		-- above taken from BF-Open
		
		if loadMaxFile f then
		(
			sFileName = maxFileName
			
			aTmp = filterString sFileName "."
			sFileName = aTmp[1]
			aTmp = filterString sFileName "_"
		
			SetSilentMode(true)
		  	--exportFile B3dFile #noPrompt
			b3d_export B3dFile
			
			gc() -- garbage collection
    	)
	)

	SetSilentMode(silent)
	escapeEnabled = true
	
	messageBox "B3d Batch Export Finished!" title: "B3d Pipeline"
)

--rollout B3dBatchProgress "B3d Batch Progress" width:340 height:140
--(
--	progressBar progress "ProgressBar" pos:[20,45] width:300 height:35
--)


rollout B3dBatchExport "B3d Pipeline Batch Export" width:500 height:170
(
	--Parameters
	dropDownList ddl_srcPath "" pos:[105,15] width:350 height:21
	button btn_srcBrowse "..." pos:[460,15] width:30 height:20
	button btn_destBrowse "..." pos:[460,45] width:30 height:20
	dropDownList ddl_destPath "" pos:[105,45] width:350 height:21
	label lbl_src "Source Path :" pos:[30,20] width:70 height:15
	label lbl_dest "Destination Path :" pos:[10,50] width:90 height:15
	checkbox chk_newer "Only Export Newer Files" pos:[300,79] width:148 height:15 checked:true
	button btn_OK "OK" pos:[345,135] width:65 height:25
	button btn_cancel "Cancel" pos:[420,135] width:65 height:25
	
	on B3dBatchExport open  do
	(
		-- ini file
		global plugcfgPath = GetDir #plugcfg
		global iniFile = plugcfgPath +"\\B3dBatchExport.ini"
		
		-- default values
		global source = #("")
		global dest = #("")
		global maxfiles = 10
		
		file = openFile iniFile 
		if (file!=undefined) then
		(
			-- read recent source paths
			count = (readLine file) as integer
			for i = 1 to count do 
			(
				source[i+1] = readLine file 
				--print source[i]
			)
			
			-- read recent dest paths
			count = (readLine file) as integer
			for i = 1 to count do 
			(
				dest[i+1] = readLine file 
				--print dest[i]
			)
			
			close file
		)
		
		ddl_srcPath.items = source
		ddl_destPath.items = dest
	)
	
	on btn_srcBrowse pressed do
	(
		path = getSavePath caption: "Pick Source Folder:"
		
		if (path!=undefined) then
		(
			source[1] = path
			ddl_srcPath.items = source
		)
	)

	on btn_destBrowse pressed do
	(
		path = getSavePath caption: "Pick Destination Folder:"
		
		if (path!=undefined) then
		(
			dest[1] = path
			ddl_destPath.items = dest
		)
	)
	
	on ddl_srcPath selected i do
	(
		if keyboard.shiftPressed then 
		(
			messageBox "aldfladfjh"
		)
	)

	on btn_ok pressed do
	(
		srcPath  = ddl_srcPath.selected
		destPath = ddl_destPath.selected
		
		if (srcPath=="") then
		(
			messageBox "Pick Source Path" title: "Gamebryo Batch Export"
		)
		else
		(
			if (destPath=="") then destPath=srcPath
			
			-- save settings
			file = openFile iniFile mode:"w" 
			
			-- save source array
			count = source.count
			if (source[1]=="") then
			(
				count = count-1
				source[1] = ddl_srcPath.selected
				ddl_srcPath.selected = ""
			)
			if (count>maxfiles) then count = maxfiles
			format "%\n" count to:file

			i = 1
			while count>0 do
			(
				if (source[i]!="") then 
				(
					format "%\n" source[i] to:file
					count = count-1
				)
				i = i + 1
			)
			
			-- save dest array
			count = dest.count
			if (dest[1]=="") then
			(
				count = count-1
				dest[1] = ddl_destPath.selected
				ddl_destPath.selected = ""
			)
			if (count>maxfiles) then count = maxfiles
			format "%\n" count to:file

			i = 1
			while count>0 do
			(
				if (dest[i]!="") then 
				(
					format "%\n" dest[i] to:file
					count = count-1
				)
				i = i + 1
			)
			
			close file
			
			-- get settings
			sourceRoot = source[1]
		  	if sourceRoot[sourceRoot.count] != "\\" then
	   			sourceRoot = sourceRoot + "\\"	
			destRoot = dest[1]
		  	if destRoot[destRoot.count] != "\\" then
	   			destRoot = destRoot + "\\"	
			newer = chk_newer.checked
			
			DestroyDialog B3dBatchExport

			nonrecursiveExport sourceRoot destRoot newer
		)
	)

	on btn_cancel pressed do
		DestroyDialog B3dBatchExport

)

CreateDialog B3dBatchExport 500 170




