rollout B3dViewerSettings "B3d Pipeline Viewer Settings" width:580 height:480
(
	--Parameters
	radioButtons rdo_size "Size" pos:[15,25] width:70 height:62 labels:#("640x480", "800x600", "1024x768") default:1 columns:1
	radioButtons rdo_bits "Bits" pos:[95,25] width:35 height:62 labels:#("16", "24", "32") default:3 columns:1
	radioButtons rdo_mode "Mode" pos:[146,25] width:76 height:46 labels:#("Full Screen", "Window") default:2 columns:1
	button btn4 "Button" pos:[50,310] width:0 height:0
	spinner spn_camnear "" pos:[60,120] width:60 height:16 range:[0,10000,1]
	spinner spn_camfov "" pos:[60,140] width:60 height:16 range:[5,160,45]
	groupBox grp3 "Screen" pos:[5,5] width:230 height:90
	groupBox grp4 "Camera" pos:[5,100] width:230 height:65
	label lbl1 "Near: " pos:[20,121] width:35 height:15
	label lbl2 "FOV: " pos:[20,141] width:30 height:15
	spinner spn_fps "" pos:[60,280] width:60 height:16 range:[0,300,30] scale:1 
	groupBox grp5 "Controls" pos:[5,170] width:230 height:85
	spinner spn_mouse "" pos:[125,190] width:55 height:16 range:[0,100,0]
	label lbl3 "Mouse Speed: " pos:[20,191] width:75 height:15
	spinner spn_move "" pos:[125,210] width:55 height:16 range:[0,100,0]
	label lbl4 "WASD Speed: " pos:[20,210] width:95 height:15
	spinner spn_scroll "" pos:[125,230] width:55 height:16 range:[0,100,0]
	label lbl5 "Zoom Speed: " pos:[20,230] width:95 height:15
	spinner spn_camfar "" pos:[165,120] width:60 height:16 range:[0,100000,1000] scale:10
	label lbl6 "Far: " pos:[135,121] width:29 height:15
	groupBox grp7 "Animation" pos:[5,260] width:230 height:45
	label lbl7 "FPS: " pos:[20,281] width:30 height:15
	button reset_mouse "Reset" pos:[185,190] width:45 height:15
	button reset_move "Reset" pos:[185,210] width:45 height:15
	button reset_scroll "Reset" pos:[185,230] width:45 height:15
	button btn_24fps "24" pos:[140,280] width:25 height:15
	button btn_30fps "30" pos:[170,280] width:25 height:15
	button btn_60fps "60" pos:[200,280] width:25 height:15
	button reset_cam "Reset" pos:[184,144] width:45 height:15
	groupBox grp_project "Project" pos:[5,310] width:230 height:130
	label lbl8 "Project Root:" pos:[15,330] width:185 height:15
	dropDownList ddl_project "" pos:[15,345] width:185 height:16
	button btn_project "..." pos:[204,346] width:25 height:18
	label lbl10 "B3d Pipeline formats some paths (e.g. XRefs) relative to a project root directory. See the B3d Pipeline docs for more info." pos:[15,375] width:218 height:62 enabled:true
	button btn_save "Save" pos:[5,450] width:95 height:25
	button btn_cancel "Cancel" pos:[170,450] width:65 height:25
	button reset_all "Defaults" pos:[105,450] width:60 height:25

--------------------------------------------------------------------
	on reset_mouse pressed  do
		spn_mouse.value = 1.0
	on reset_move pressed  do
		spn_move.value = 1.0
	on reset_scroll pressed  do
		spn_scroll.value = 1.0
	on btn_24fps pressed  do
		spn_fps.value = 24.0
	on btn_30fps pressed  do
		spn_fps.value = 30.0
	on btn_60fps pressed  do
		spn_fps.value = 60.0
	on reset_cam pressed  do
	(
		spn_camnear.value = 1.0 		
		spn_camfar.value = 1000.0
		spn_camfov.value = 45.0
	)
	on reset_all pressed  do

	(
		spn_fps.value = 30.0
		spn_scroll.value = 1.0
		spn_move.value = 1.0
		spn_mouse.value = 1.0
		spn_camnear.value = 1.0
		spn_camfar.value = 1000.0
		spn_camfov.value = 45.0
		rdo_size.state = 1 		
		rdo_bits.state = 3 		
		rdo_mode.state = 2
	)
	
/*	on btn_help pressed do
	(
		helpPath = GetDir #help
		helpFile = helpPath +"\B3dPipelineDocs\B3dViewer.htm"
		--print helpFile
		ShellLaunch helpFile ""
	)
*/
	
	on B3dViewerSettings open  do
	(
		pluginPath = GetDir #plugcfg  +"\\"
		iniFile = pluginPath +"B3dViewer.ini"
		iniPrj = pluginPath +"B3dProjects.ini"

		if (getFiles iniFile).count != 0 then
		(
			-- viewer settings
			rdo_size.state = (getINISetting iniFile "Viewer" "Resolution" as integer)	
			rdo_bits.state = (getINISetting iniFile "Viewer" "Bitdepth" as integer)	
			rdo_mode.state = (getINISetting iniFile "Viewer" "Mode" as integer)	
			spn_camnear.value = (getINISetting iniFile "Viewer" "CamNear" as float)	
			spn_camfar.value = (getINISetting iniFile "Viewer" "CamFar" as float)	
			spn_camfov.value = (getINISetting iniFile "Viewer" "CamFOV" as float)	
			spn_mouse.value = (getINISetting iniFile "Viewer" "Mouse" as float)	
			spn_move.value = (getINISetting iniFile "Viewer" "Move" as float)	
			spn_scroll.value = (getINISetting iniFile "Viewer" "Scroll" as float)	
			spn_fps.value = (getINISetting iniFile "Viewer" "FPS" as float)	
		)
		
		-- project settings
		
		global projects = #("")
		global maxprojects = 10
		file = openFile iniPrj
		if (file!=undefined) then
		(
			-- read recent projects
			count = (readLine file) as integer
			for i = 1 to count do 
			(
				projects[i] = readLine file 
			)
			close file
		)
		
		ddl_project.items = projects
	)

	on btn_project pressed do
	(
		path = getSavePath caption: "Pick Project Folder:"
		
		if (path!=undefined) then
		(
			insertItem path projects 1
			ddl_project.items = projects
			ddl_project.selection = 1
		)
	)

	on ddl_project selected i do
	(
	)

	on btn_save pressed do
	(
		pluginPath = GetDir #plugcfg +"\\"
		iniFile = pluginPath +"B3dViewer.ini"
		iniPrj = pluginPath +"B3dProjects.ini"

		-- viewer settings
		setINISetting iniFile "Viewer" "Resolution"	(rdo_size.state as string)
		setINISetting iniFile "Viewer" "Bitdepth" (rdo_bits.state as string)
		setINISetting iniFile "Viewer" "Mode" (rdo_mode.state as string)
		setINISetting iniFile "Viewer" "CamNear" (spn_camnear.value as string)
		setINISetting iniFile "Viewer" "CamFar" (spn_camfar.value as string)
		setINISetting iniFile "Viewer" "CamFOV" (spn_camfov.value as string)
		setINISetting iniFile "Viewer" "Mouse" (spn_mouse.value as string)
		setINISetting iniFile "Viewer" "Move" (spn_move.value as string)
		setINISetting iniFile "Viewer" "Scroll" (spn_scroll.value as string)
		setINISetting iniFile "Viewer" "FPS" (spn_fps.value as string)
		
		-- project
		file = openFile iniPrj mode:"w"
		
		proj = ddl_project.selected
		deleteItem projects ddl_project.selection
		insertItem proj projects 1
		
		count = projects.count
		if count>maxprojects then count = maxprojects
		format "%\n" count to:file
		
		for i = 1 to count do
		(
			format "%\n" projects[i] to:file
		)

		DestroyDialog b3dViewerSettings
	)
	on btn_cancel pressed do
		DestroyDialog b3dViewerSettings
		
)

CreateDialog b3dViewerSettings 240 480

