Include "$scripts/startup/B3dBrush.ms"	-- not sure why I need to do this!
Include "$scripts/startup/B3dMap.ms"	-- but B3dBrush/Map not recognized otherwise!

fn B3dSelectByMaterial mtl = 
(
	-- This Function Based On:
	-- Select Nodes by Materials
	-- designed by hab, Mar 11th, 2000
	
	-- get the selected materials name
	format "\n--\n"
	format "-- Material: %\n" mtl.name
	
	-- select all nodes
	-- select $*
	max select all
	getCurrentSelection 
	allSel = selection as array
	format "-- # of nodes: %\n" allSel.count
		
	-- clear the selection
	-- clearSelection should work, isn't it?
	-- deselect $*
	max select none
		
	-- select nodes with that material
	for i in 1 to allSel.count do
	(
		selNode = allSel[i]
		if (not selnode.material == undefined) then
		(
--			format "-- node: %\n" selNode.material.name
			if (selnode.material.name == mtl.name) then
			(
--				format "-- node: %\n" selNode.name
				selectMore selnode
			)
		)	
	)
	format "-- done.\n"
)

fn bitmapToB3d a =
(
	if classof a == Bitmaptexture then
	(
		local b = B3dMap()
		b.name = a.name
		if doesfileexist a.filename then
		(
			if a.bitmap != undefined then b.delegate.bitmap = a.bitmap
		)
		b.delegate.fileName = a.fileName
		b.uoffset = a.coords.U_Offset
		b.voffset = a.coords.V_Offset
		b.utile = a.coords.U_Tiling
		b.vtile = a.coords.V_Tiling
		b.rotation = a.coords.W_Angle
		b.clampu = not a.coords.U_Tile
		b.clampv = not a.coords.V_Tile
		b.channel = a.coords.mapChannel
		b
	)
	else a
)

fn standardToB3d a = 
(
	print a
	b = B3dBrush()
	print b
	b.name = a.name
	b.color = a.diffuse
	b.alpha = a.opacity
	b.shine = a.SpecularLevel
	b.flatshaded = a.faceted
	b.twosided = a.twoSided
	if a.selfIllumAmount > 75 then b.fullbright = true
	if a.diffuseMap != undefined then 
	(
		b.on1 = a.diffuseMapEnable
		b.map1 = bitmapToB3d a.diffuseMap
		showTextureMap b b.map1 on
	)
	b	-- return B3dBrush
)

fn raytraceToB3d a = 
(
	local b = B3dBrush()
	b.name = a.name
	b.color = a.diffuse
	b.alpha = 100-(((a.Transparecy.v)/255)*100)
	b.shine = a.Specular_Level
	--b.flatshaded = a.faceted --??? Where is it ???
	b.twosided = a.twoSided 
	if a.Self_Illum_Amount > 75 then b.fullbright = true
	if a.diffuseMap != undefined then 
	(
		b.on1 = a.diffuseMapEnable
		b.map1 = a.diffuseMap
		showTextureMap b b.map1 on
	)
	b	-- return B3dBrush
)

fn convertToB3d a =
(
	b = a
	if classof a == Multimaterial then b = multiToB3d(a) 
	else if classof a == Standard then b = standardToB3d(a)
	else if classof a == RaytraceMaterial then b = raytraceToB3d(a)
	b	-- return B3dBrush
)

fn multiToB3d a =
(
	local b
	sub_number = a.names.count
	b = Multimaterial()
	b.materialList.count = sub_number
	b.name = a.name
	for i = 1 to sub_number do
	(
		b.materialList[i] = a.materialList[i]
		b.mapEnabled[i] = a.mapEnabled[i]
		if a.names[i] != undefined then b.names[i] = a.names[i]
	)
	for i = 1 to sub_number do
	(
		b.materialList[i] = convertToB3d(b.materialList[i])
	)
	b	-- return B3dBrush
)

fn convertMaterialToB3d a =
(
	local b = convertToB3d a

	if b!= undefined then
	(
		B3dSelectByMaterial a
		if $ != undefined then $.material = b
	)
	b 	-- return B3dBrush (maybe)
)
	
fn convertMeditSlotToB3d num = 
(
	local b = convertMaterialToB3d meditMaterials[num]

	if b!= undefined then meditMaterials[num] = b
	else format "Could Not Convert Material\n"
)

fn convertSceneMtlsToB3d =
(
	local esc = escapeEnable
	escapeEnable = false
	disableSceneRedraw()
	progressStart("Convert to B3d Brush/Map")
	-- first convert all mtls in medit
	for i = 1 to 24 do convertMeditSlotToB3d(i)
	-- now convert scene materials
	local count = sceneMaterials.count
	for i = 1 to count do
	(
		progressUpdate(100.0*i/count)
		if getProgressCancel() then exit
		convertMaterialToB3d sceneMaterials[i]
	)
	progressEnd()
	escapeEnable = esc
	enableSceneRedraw()
)
	
--if (queryBox "Convert All Scene Materials to B3d Brush/Map?") then convertSceneMtlsToB3d()
